★HDU 4283 You Are the One(思维区间DP)

16 篇文章 3 订阅


You Are the One

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3696    Accepted Submission(s): 1699


Problem Description
  The TV shows such as You Are the One has been very popular. In order to meet the need of boys who are still single, TJUT hold the show itself. The show is hold in the Small hall, so it attract a lot of boys and girls. Now there are n boys enrolling in. At the beginning, the n boys stand in a row and go to the stage one by one. However, the director suddenly knows that very boy has a value of diaosi D, if the boy is k-th one go to the stage, the unhappiness of him will be (k-1)*D, because he has to wait for (k-1) people. Luckily, there is a dark room in the Small hall, so the director can put the boy into the dark room temporarily and let the boys behind his go to stage before him. For the dark room is very narrow, the boy who first get into dark room has to leave last. The director wants to change the order of boys by the dark room, so the summary of unhappiness will be least. Can you help him?
 

Input
  The first line contains a single integer T, the number of test cases.  For each case, the first line is n (0 < n <= 100)
  The next n line are n integer D1-Dn means the value of diaosi of boys (0 <= Di <= 100)
 

Output
  For each test case, output the least summary of unhappiness .
 

Sample Input
  
  
2    5 1 2 3 4 5 5 5 4 3 2 2
 

Sample Output
  
  
Case #1: 20 Case #2: 24
 

Source

题目:有一个队列,每个人有一个愤怒值D,如果他是第K个上场,不开心指数就为(K-1)*D。但是边上有一个小黑屋(其实就是个堆栈),可以一定程度上调整上场程序

思路:这题我根本想不到操作第一个人。。。其实题意也可以这样翻译:

有一个队列,n个人轮流上台演出。每个人有一个值,n个人预先是排好队伍的。

操作:

1.队伍第一个人上台

2.队伍第一个人压栈

3.栈顶第一个人上台

每个人有一个K值,如果这个人是第 i 个上台,那么他会获得k*(i-1)的值,求最小值。

dp[i][j]表示从第i个人到第j个人这段区间的最小花费(是只考虑这j-i+1个人,不需要考虑前面有多少人)
那么对于dp[i][j]的第1个人,就有可能第1个上场,也可以第j-i+1个上场。考虑第K个上场
即在i+1之后的K-1个人是率先上场的,那么就出现了一个子问题 dp[i+1][i+1+k-1-1]表示在第i个人之前上场的
对于第i个人,由于是第k个上场的,那么愤怒值便是val[i]*(k-1)
其余的人是排在第k+1个之后出场的,也就是一个子问题dp[i+k][j],对于这个区间的人,由于排在第k+1个之后,所以dp[i+k][j]整体愤怒值要加上k*(sigma(i+k--j))

这个DP的转移方程巧妙的包括了栈的所有情况,而且没有多余的情况。。

这个跟那个扑克牌的有点类似,扑克牌那个考虑的是最后一个拿走的扑克牌,这个考虑的是第一个人的出队时间,这两个题比较一下:扑克牌区间DP

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <cstring>
using namespace std;
const int maxn = 1e2 + 5;
const int inf = 1e9;
int dp[maxn][maxn], sum[maxn], n, a[maxn];
int main()
{
    int t, ca = 1;
    scanf("%d", &t);
    while(t--)
    {
        scanf("%d", &n);
        memset(dp, 0, sizeof(dp));
        memset(sum, 0, sizeof(sum));
        for(int i = 1; i <= n; i++)
        {
            scanf("%d", &a[i]);
            sum[i] = sum[i-1] + a[i];
        }
        for(int i = 1; i <= n; i++)
            for(int j = i+1; j <= n; j++)
        {
//            if(i == j)
//                dp[i][j] = a[i];
//            else
                dp[i][j] = inf;
        }
        for(int len = 1; len < n; len++)
        {
            for(int i = 1; i + len <= n; i++)
            {
                int j = i + len;
                for(int k = i; k <= j; k++)
                {
                    dp[i][j] = min(dp[i][j], a[i]*(k-i)+(k-i+1)*(sum[j]-sum[k])+dp[i+1][k]+dp[k+1][j]);
                }
            }
        }
        printf("Case #%d: %d\n", ca++, dp[1][n]);
    }
    return 0;
}


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值